from tkinter import *
import resumeOptions
import copy

def numberOfButtons(data, n):
    #takes the number of buttons and returns a list of starting Y coordinates
    print("NUMBER BUTTON")
    remaining = int(data.height - data.margin)
    space = int(remaining/n)
    for i in range( n):
        data.xList += [(data.margin + (space * i))]
        
def textButton(data, canvas, text, startCoords):
    x = data.buttonX
    width = data.buttonWidth
    height = data.buttonHeight
    counter = 0
    data.buttonList = []
    for item in startCoords:
        canvas.create_rectangle(x, item, (x + width), (item + height),
                                fill="Aquamarine1")
        canvas.create_text((x + (width/2)), (item + (height/2)),
                            text = text[counter], fill="black")
        data.buttonList += [x, item, (x + width), (item + height)]
        counter += 1

def ifButtonPressed(event, data):
    #takes in a click position, checks to see if it hits a button
    #check how many buttons are in the data.xList
    numInputs = len(data.xList)
    #check if button was pressed
    buttonListCopy = copy.deepcopy(data.buttonList)
    #get list of x and y coords
    listX = []
    listY = []
    counter = 0
    while (len(buttonListCopy) > 0):
        for i in range(4):
            #separate list into x and y coords
            if (i % 2) == 0:
                listX += [buttonListCopy[i]]
            else:
                listY += [buttonListCopy[i]]
        if (listX[0] <= event.x) and (listX[1] >= event.x) and \
            (listY[0] <= event.y) and (listY[1] >= event.y):
            #if button for age, assign corresponding setting
            if(len(data.buttonList) == 12):
                print("AGE")
                data.age = data.ageValues[counter]
                print(data.age)
            elif(len(data.buttonList) == 16):
                data.occupation = data.jobText[counter]
                print(data.occupation)
            #if button for occupation, assign corresponding setting
            return(TRUE)
        else:
            try:
                buttonListCopy = buttonListCopy[4:]
            except:
                pass
        listX = []
        listY = []
        counter += 1
    
#set resume info
def getOccupation(data):
    data.profileText = resumeOptions.randomizeProfile(data.age, data.occupation)

def getExperience(data):
    data.experienceText = resumeOptions.randomizeExperience(data.age, \
                            data.occupation)
    counter = 0
    text = ""
    for item in data.experienceText:
        for i in range(len(data.experienceText[counter])):
            text += data.experienceText[counter][i]
        counter += 1
    print(text)
    data.experienceText = text 

def getSkills(data):
    data.skillsText = resumeOptions.returnSkills(data.occupation)

def getReferences(data):
    data.referencesText = resumeOptions.returnReferences(data.occupation)
    
####################################
# init
####################################

def init(data):
    data.mode = "home"
    data.score = 0
    data.buttonList = []
    data.margin = data.height/3
    data.xList = []
    data.buttonNumbers = 3
    data.jobButtons = 4
    data.buttonX = data.width/4
    data.buttonWidth = data.width/2
    data.buttonHeight = data.height/8
    data.age = 0
    data.occupation = ""
    data.ageText = ["16-25", "26-35", "36- "]
    data.ageValues = [1, 2, 3]
    data.jobText = ["CEO", "Artist", "Musician", "Athlete"]
    #resume margins
    data.sideMargin = data.width/15
    data.profileTop = data.height/4.75
    data.experienceTop = (data.height/4.5) * 1.55
    data.skillsTop = (data.height/4.75) * 3.25
    data.referencesTop = (data.height/4.75) * 4.15
    #text written on resume
    data.profileText = ""
    data.experienceText = ""
    data.skillsText = ""
    data.referencesText = ""

####################################
# mode dispatcher
####################################

def mousePressed(event, data):
    if (data.mode == "home"): homeMousePressed(event, data)
    elif (data.mode == "age"):   ageMousePressed(event, data)
    elif (data.mode == "job"):   jobMousePressed(event, data)
    elif (data.mode == "skill"):   skillMousePressed(event, data)
    elif (data.mode == "resume"):   resumeMousePressed(event, data)

def keyPressed(event, data):
    if (data.mode == "home"): homeKeyPressed(event, data)
    elif (data.mode == "age"):   ageKeyPressed(event, data)
    elif (data.mode == "job"):   jobKeyPressed(event, data)
    elif (data.mode == "skill"):   skillKeyPressed(event, data)
    elif (data.mode == "resume"):   resumeKeyPressed(event, data)

def timerFired(data):
    if (data.mode == "home"): homeTimerFired(data)
    elif (data.mode == "age"):   ageTimerFired(data)
    elif (data.mode == "job"):   jobTimerFired(data)
    elif (data.mode == "skill"):   skillTimerFired(data)
    elif (data.mode == "resume"):   resumeTimerFired(data)

def redrawAll(canvas, data):
    if (data.mode == "home"): homeRedrawAll(canvas, data)
    elif (data.mode == "age"):   ageRedrawAll(canvas, data)
    elif (data.mode == "job"):   jobRedrawAll(canvas, data)
    elif (data.mode == "skill"):   skillRedrawAll(canvas, data)
    elif (data.mode == "resume"):   resumeRedrawAll(canvas, data)

####################################
# home mode
####################################

def homeMousePressed(event, data):
    pass

def homeKeyPressed(event, data):
    p = numberOfButtons(data, data.buttonNumbers)
    data.mode = "age"
    
def homeTimerFired(data):
    pass

def homeRedrawAll(canvas, data):
    canvas.create_text(data.width/2, data.height/2-20,
                       text="Dream Resume Generator", font="Arial 26 bold")
    canvas.create_text(data.width/2, data.height/2+20,
                       text="Press any key to begin", font="Arial 20")


####################################
# age mode
####################################

def ageMousePressed(event, data):
    if(ifButtonPressed(event, data) == TRUE):
       data.xList = []
       p = numberOfButtons(data, data.jobButtons)
       data.mode = "job"
    print(data.buttonList)

def ageKeyPressed(event, data):
    pass

def ageTimerFired(data):
    pass

def ageRedrawAll(canvas, data):
    canvas.create_rectangle(0, 0, data.width, data.height, fill="Thistle1")
    canvas.create_text(data.width/2, data.height/5,
                       text="Please select your age range", font="Arial 26 bold")
    textButton(data, canvas, data.ageText, data.xList)


####################################
# job mode
####################################

def jobMousePressed(event, data):
    if(ifButtonPressed(event, data) == TRUE):
       data.xList = []
       getOccupation(data)
       getExperience(data)
       getSkills(data)
       getReferences(data)
       data.mode = "resume"

def jobKeyPressed(event, data):
    pass

def jobTimerFired(data):
    pass

def jobRedrawAll(canvas, data):
    canvas.create_rectangle(0, 0, data.width, data.height, fill="LightGoldenrod2")
    canvas.create_text(data.width/2, data.height/5,
                       text="Please select your dream job", font="Arial 26 bold")
    textButton(data, canvas, data.jobText, data.xList)


####################################
# skill mode
####################################

def skillMousePressed(event, data):
    pass

def skillKeyPressed(event, data):
    data.mode = "playGame"

def skillTimerFired(data):
    pass

def skillRedrawAll(canvas, data):
    canvas.create_text(data.width/2, data.height/2-40,
                       text="This is help mode!", font="Arial 26 bold")
    canvas.create_text(data.width/2, data.height/2-10,
                       text="How to play:", font="Arial 20")
    canvas.create_text(data.width/2, data.height/2+15,
                       text="Do nothing and score points!", font="Arial 20")
    canvas.create_text(data.width/2, data.height/2+40,
                       text="Press any key to keep playing!", font="Arial 20")                       

####################################
# resume mode
####################################

def resumeMousePressed(event, data):
    pass

def resumeKeyPressed(event, data):
    data.mode = "playGame"

def resumeTimerFired(data):
    pass

def resume(canvas, data):
    topMargin = data.height/7.5
    sideMargin = data.width/15
    canvas.create_text(sideMargin, topMargin, anchor=SW, 
                        text="Resume", font="Futura 60")

def profile(canvas, data):
    topMargin = data.height/5
    sideMargin = data.width/15
    canvas.create_rectangle(sideMargin, topMargin, 
                            data.width - sideMargin, 
                            (topMargin + 2), fill="black")
    canvas.create_text(sideMargin, topMargin, anchor=SW,
                        text="Profile", font="Futura 30")

def experience(canvas, data):
    topMargin = (data.height/5) * 1.75
    sideMargin = data.width/15
    
    canvas.create_rectangle(sideMargin, topMargin, 
                            data.width - sideMargin, 
                            (topMargin + 2), fill="black")
    canvas.create_text(sideMargin, topMargin, anchor=SW,
                        text="Experience", font="Futura 30")

def skills(canvas, data):
    topMargin = (data.height/5) * 3.25
    sideMargin = data.width/15
    canvas.create_rectangle(sideMargin, topMargin, 
                            data.width - sideMargin, 
                            (topMargin + 2), fill="black")
    canvas.create_text(sideMargin, topMargin, anchor=SW,
                        text="Skills", font="Futura 30")

def reference(canvas, data):
    topMargin = (data.height/5) * 4.25
    sideMargin = data.width/15
    canvas.create_rectangle(sideMargin, topMargin, 
                            data.width - sideMargin, 
                            (topMargin + 2), fill="black")
    canvas.create_text(sideMargin, topMargin, anchor=SW,
                        text="Reference", font="Futura 30")


def resumeRedrawAll(canvas, data):
    resume(canvas, data)
    profile(canvas, data)
    experience(canvas, data)
    skills(canvas, data)
    reference(canvas, data)
    canvas.create_text(data.sideMargin, data.profileTop, anchor=NW, 
                        text=data.profileText, font = "Futura 20")
    canvas.create_text(data.sideMargin, data.experienceTop, anchor=NW, 
                        text=data.experienceText, font = "Futura 20")
    canvas.create_text(data.sideMargin, data.skillsTop, anchor=NW, 
                        text=data.skillsText, font = "Futura 20")
    canvas.create_text(data.sideMargin, data.referencesTop, anchor=NW, 
                        text=data.referencesText, font = "Futura 20")    


####################################

def run(width=300, height=300):
    def redrawAllWrapper(canvas, data):
        canvas.delete(ALL)
        canvas.create_rectangle(0, 0, data.width, data.height,
                                fill='white', width=0)
        redrawAll(canvas, data)
        canvas.update()    
    def mousePressedWrapper(event, canvas, data):
        mousePressed(event, data)
        redrawAllWrapper(canvas, data)
    def keyPressedWrapper(event, canvas, data):
        keyPressed(event, data)
        redrawAllWrapper(canvas, data)
    def timerFiredWrapper(canvas, data):
        timerFired(data)
        redrawAllWrapper(canvas, data)
        canvas.after(data.timerDelay, timerFiredWrapper, canvas, data)
    class Struct(object): pass
    data = Struct()
    data.width = width
    data.height = height
    data.timerDelay = 100 
    root = Tk()
    init(data)
    canvas = Canvas(root, width=data.width, height=data.height)
    canvas.pack()
    root.bind("<Button-1>", lambda event:
                            mousePressedWrapper(event, canvas, data))
    root.bind("<Key>", lambda event:
                            keyPressedWrapper(event, canvas, data))
    timerFiredWrapper(canvas, data)
    root.mainloop()

run(600, 900)